
;OK version v. 22-7-02
;--------------------------------------------------------------------------------------------
;-----------------------------------RC5 Automaten include file  -----------------------------
;--------------------------------------------------------------------------------------------
;----------Zyklische Abarbeitung durch 222s interrupt Aufruf -------------------------------
;----------basis: Fclk=7,72328Mhz <=> 135ns Tcycle ...==> max. 411 befehle/timeslot ! -------
;--------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------
;------ folgende flag's werden gesetzt:            toggle,compl
;--------------------------------------------------------------------------------------------
;portD pin1 scannt rc5 code !
;OK - version vom 20-07-02 
;--------------------------------------------------------------------------------------------------------------------
;codes
;12  = on/off (sby)
;0-9 = numerik
;16  = up (+)
;17  = dw (-)
;53  = prog (play)
;
;
;
;
;0x86 =	rc5-decFLAG
;0x87 = rc5state
;0x88 =	rc5-biSTEP
;0x89 = temp.rc5 adresse
;0x8a =	temp.rc5 daten			              


comSTATE:
	;lokale registerdefinition

	lds	r17,0x86	;decFLAG
	lds	r18,0x87	;rc5state
	lds	r19,0x88	;biSTEP
	lds	r16,0x89	;temp.rc5 adresse
	lds	r22,0x8a	;temp.rc5 daten	



	rcall	_takeNXT	;taste ir-pin ab !!!
	
	
	
	;Weise Automatenzustand einem Ereignis zu
	cpi	r18,20	;warte auf startsequenz ??? (nach ruhe...)
	breq	_svGO		;yes...
	
	cpi	r18,33	;startsequenz erkannt ????
	breq	_stOK	

	cpi	r18,42	;nutzbit ,1' erkannt
	breq	_HIbit
	
	cpi	r18,50	;nutzbit ,0' erkannt
	breq	_LObit
	
	rjmp	_svGO
	



;----------------------------------------------------------------------------
;rcksprung aus routine
;----------------------------------------------------------------------------
_stOK:
	clr	r19		;bitcounter 0
		
_svGO:
	;backup lokaler registerdefinitionen

	sts	0x86,r17		;decFLAG ---> ,compl' <=> high (nach Ausfhrung lschen !)
	sts	0x87,r18		;rc5state---> decoder status   (intern relevant)
	sts	0x88,r19		;biSTEP  ---> bit counter      (intern relevant)
	sts	0x89,r16		;temp.rc5 adresse
	sts	0x8a,r22		;temp.rc5 daten
	ret



;---------------------------------------------------------------------------
;decodiere nutzbits 1/0 und bilde adress-/data frame
;---------------------------------------------------------------------------
_HIbit:
	inc	r19
	set	
	rjmp	A_CObit
_LObit:	
	inc	r19
	clt

;----> bit count=1
A_CObit:
	cpi	r19,1
	brne	B_CObit
	brtc	toLO
	sbr	r17,1<<toggle		;t-flag <=> toggle bit !
	;
	rjmp	_svGO			;und tsch
toLO:
	cbr	r17,1<<toggle		
	;
;	cbi	portb,pinb7
	rjmp	_svGO
	
	
;-----> bit count = 2-6 (adresse)
B_CObit:
	cpi	r19,7
	brlo	C_CObit
	
	cpi	r19,7
	brsh	D_CObit
	 	
	rjmp	_svGO

C_CObit:
	rol	r16			;
	bld	r16,0			;copy t-flag -> bit0
	rjmp	_svGO

;-----> bit count	= 7-12 (daten)
D_CObit:
	rol	r22
	bld	r22,0			;copy t-flag -> bit0
	
	cpi	r19,12
	brsh	_svGOA
	rjmp	_svGO	

	;komplett!!!!!!!!!
_svGOA:	
	
	sbr	r17,1<<complete		;transfer complete !!
	cbr	r22,1<<6			;daten max. 6bit
	cbr	r22,1<<7
	;
	clr	r18			;prozecounter 0
	clr	r19			;bit counter 0
	;	
	rjmp	_svGO


;--------------------------------------------------------------------------------------
;auto decoder
;--------------------------------------------------------------------------------------


_takeNXT: 
	clr	r20
	sbis	pind,rc5
	rjmp	_setcarry
	clc
_state:	
	rol	r18
	ldi	zl,low (_tbREMOTE *2)
	ldi	zh,high(_tbREMOTE *2)
	add	zl,r18
	adc	zh,r20
	lpm			;tabelleninhalt (byte n --> r0) 
	mov	r18,r0		;tabelleninhalt (r0     --> zustand)
	ret
_setcarry:	
	sec
	rjmp	_state

.cseg

	;folgezustnde bei		Zustandsschritt
	;IR=0  IR=1
	;   |   |
_tbREMOTE:
				;	check pause	
	.db	1,	0	;	0		
	.db	2,	0	;	1		
	.db	3,	0	;	2	
	.db	4,	0	;	3		
	.db	5,	0	;	4	
	.db	6,	0	;	5		
	.db	7,	0	;	6		
	.db	8,	0	;	7		
	.db	9,	0	;	8		
	.db	10,	0	;	9		
	.db	11,	0	;	10		
	.db	12,	0	;	11		
	.db	13,	0	;	12		
	.db	14,	0	;	13		
	.db	15,	0	;	14		
	.db	16,	0	;	15		
	.db	17,	0	;	16		
	.db	18,	0	;	17		
	.db	19,	0	;	18		
	.db	20,	0	;	19		
	.db	20,	21	;	20		
	
	
				;	check startsequenz
	.db	0,	22	;	21		
	.db	0,	23	;	22		
	.db	26,	24	;	23		
	.db	26,	25	;	24		
	.db	26,	0	;	25		
	.db	27,	0	;	26		
	.db	28,	0	;	27		
	.db	29,	31	;	28		
	.db	30,	31	;	29		
	.db	0,	31	;	30		
	.db	0,	32	;	31		
	.db	0,	33	;	32		
	.db	35,	34	;	33		
	
	
				;	routing bit level
	.db	35,	43	;	34		
	
	
				;	detect	,1'-bit
	.db	36,	43	;	35		
	.db	37,	0	;	36		
	.db	38,	40	;	37		
	.db	39,	40	;	38		
	.db	0,	40	;	39		
	.db	0,	41	;	40		
	.db	0,	42	;	41		
	.db	35,	34	;	42		
	
	
				;	detect	,0'-bit
	.db	35,	44	;	43		
	.db	0,	45	;	44		
	.db	48,	46	;	45		
	.db	48,	47	;	46		
	.db	48,	0	;	47		
	.db	49,	0	;	48		
	.db	50,	0	;	49		
	.db	34,	35	;	50		
	
.exit


