;*******************************************
;timer0 - interrupt-loop (55,3s-Zyklus) 
;*******************************************
_timiLOOP:
	;status-register auf den stack
	in	r5,sreg		
	push	r5
	;zuerst timer 0 reload !
	ldi	r24,tiREL	;reload timer0 --> nach jedem overload folgt ein reload !!
	out	tcnt0,r24
	;erlaube weitere interrupts
	sei

;**************************************************
;timebase generieren
;**************************************************
;0x80 = 55,5S-counter
;0x81 = 1ms-counter

;0x83 = 20ms-counter
;0x84 = 100ms-counter

;
;0x75 = 1ms-flags
;0x76 = 10ms-flags
;0x77 = 20ms-flags
;0x78 = 100ms-flags
;0x79 =	1s-flags
;


_base1ms_cnt:
	;zuerst phasecut_unit
	;... stabiler
	rcall	phasecut_unit
	;
	lds	r16,0x80
	cpi	r16,18
	brlo	_base1ms_nok
	;55,3s-counter =1
	ldi	r16,1
	sts	0x80,r16
	;1ms-flags setzen
	ldi	r16,0xff
	sts	0x75,r16
	;
	;1ms-counter +1
	lds	r16,0x81
	cpi	r16,10
	brne	_base20ms_cnt
	inc	r16
	sts	0x81,r16
	;10ms-flags setzen 
	ldi	r16,0xff
	sts	0x76,r16
	rjmp	_timiCOMP

	;55,3s-counter +1
_base1ms_nok:
	inc	r16
	sts	0x80,r16
	rjmp 	_timiCOMP


	;20ms?
_base20ms_cnt:
	cpi	r16,20
	brne	_base1msUP
	ldi	r16,1
	sts	0x81,r16
	;20ms&10ms-flags setzen
	ldi	r16,0xff
	sts	0x77,r16
	sts	0x76,r16
	;20ms-counter inc
	lds	r16,0x83
	cpi	r16,5
	brsh _base100ms_cnt	
	inc	r16
	sts	0x83,r16
	;
	rjmp	_timiCOMP
_base1msUP:
	inc	r16
	sts	0x81,r16
	rjmp	_timiCOMP

	;100ms?
_base100ms_cnt:
	ldi	r16,1
	sts	0x83,r16
	;100ms-flags setzen
	ldi	r16,0xff
	sts	0x78,r16
	;
	;100ms-counter
	lds	r16,0x84
	cpi	r16,10
	brsh _base1s_ok
	inc	r16
	sts	0x84,r16
	rjmp	_timiCOMP
	;1s
_base1s_ok:
	ldi	r16,1
	sts	0x84,r16
	;1s-flags setzen
	ldi	r16,0xff
	sts	0x79,r16
	rjmp	_timiCOMP
	;	
	;------------------------------
	;
_timiCOMP:
	;alle 55,3s ausfhren...
	;	
	tst		timiVAR
	brne	_timiCOMPa
	ldi		timiVAR,4		;4 step
_timiCOMPa:	
	;alle 166s ausfhren
	cpi		timiVAR,1
	brne	_timiCOMPb
	rcall	key_dec	
	;
_timiCOMPb:	
	;alle 166s ausfhren
	cpi		timiVAR,2
	brne	_timiCOMPc
	rcall	_soft_ud	
	;			;
_timiCOMPc:	
	;alle 166s ausfhren
	cpi		timiVAR,3
	brne	_timiCOMPd
	rcall	led_unit	
	;
_timiCOMPd:	
	;alle 222s ausfhren
	cpi		timiVAR,4
	brne	_timiCOMPback
	rcall	comSTATE
	;
_timiCOMPback:
	dec		timiVAR

_timiBK:
	pop		r5
	out	    sreg,r5
	reti

